<?php
/**
 * Body for CryptoPhoto extension
 * 
 * @file
 * @ingroup Extensions
 */

class CryptoPhoto {
  /**
   * Hook for user preferences
   */
  public static function GetPreferences( $user, &$preferences ) {
    global $wgOut, $wgCryptoPhotoConfig;
    
    //test for non-empty keys
    if(isset($wgCryptoPhotoConfig['privatekey']) && isset($wgCryptoPhotoConfig['publickey'])) {

      $preferences['cryptophoto_enabled'] = array(
        'section' => 'CryptoPhoto/CryptoPhotoSettings',
        'type' => 'toggle',
        'label-message' => 'cryptophoto-pref-enabled',
      );

      $userid = $user->getId();

      //new the cryptophoto instance
      $cp = new CryptoPhotoUtils($wgCryptoPhotoConfig['privatekey'], 
                                 $wgCryptoPhotoConfig['publickey'], 
                                 md5($wgCryptoPhotoConfig['salt'] . $userid));

      //start a new session
      $cp->start_session();

      $preferences['cryptophoto_js'] = array(
        'section' => 'CryptoPhoto/CryptoPhotoSettings',
        'type' => 'info',
        'label' => '',
        'default' => $cp->get_gen_widget(),
        'raw' => true // if true, the above string won't be html-escaped
      );
    }
   
    return true;
  }
}
?>
